/*
 *  Copyright (C) 2006-2007, Renaud Lottiaux, Kerlabs.
 */

#include <linux/module.h>
#include <linux/msg.h>
#include <linux/ipc_util.h>
#include <linux/ipc.h>
#include <linux/shm.h>
#include <linux/mm.h>
#include <linux/lockdep.h>
#include <linux/syscalls.h>


/** Kerrighed Kernel Hooks **/

/* Cluster wide SHM management */

struct shmid_kernel * (*kh_shm_lock)(struct ipc_namespace *ns, int id) = NULL;
void (*kh_shm_unlock)(struct shmid_kernel *shp) = NULL;

int (*kh_shm_newseg) (struct ipc_namespace *ns,
		      struct shmid_kernel * shp) = NULL;
void (*kh_shm_destroy)(struct ipc_namespace *ns,
		       struct shmid_kernel *shp) = NULL;
void (*kh_shm_rmkey)(struct ipc_namespace *ns, key_t key) = NULL ;

int (*kh_ipc_get_max_id)(struct ipc_namespace *ns, struct ipc_ids* ids) = NULL;
int (*kh_get_ipc_id)(struct ipc_ids *ids, int size) = NULL;
int (*kh_ipc_findkey)(struct ipc_ids *ids, key_t key) = NULL;

struct msg_queue * (*kh_ipcmsg_lock)(struct ipc_namespace *ns, int id) = NULL;
void (*kh_ipcmsg_unlock)(struct msg_queue *msq) = NULL;

int (*kh_ipcmsg_newque)(struct ipc_namespace *ns,
			 struct msg_queue * msq) = NULL;
void (*kh_ipcmsg_freeque)(struct ipc_namespace *ns,
			  struct msg_queue * msq, int id) = NULL;
long (*kh_ipcmsg_rmid)(int msqid) = NULL;
long (*kh_ipc_msgsnd)(int msqid, long mtype, void __user *mtext,
		       size_t msgsz, int msgflg, struct ipc_namespace *ns,
		       pid_t tgid) = NULL;
long (*kh_ipc_msgrcv)(int msqid, long *pmtype, void __user *mtext,
		       size_t msgsz, long msgtyp, int msgflg,
		       struct ipc_namespace *ns, pid_t tgid) = NULL;

struct sem_array * (*kh_ipcsem_lock)(struct ipc_namespace *ns, int id) = NULL;
void (*kh_ipcsem_unlock)(struct sem_array *sma) = NULL;

int (*kh_ipcsem_newary)(struct ipc_namespace *ns,
			   struct sem_array * sma) = NULL;
void (*kh_ipcsem_freeary)(struct ipc_namespace *ns,
			  struct sem_array *sma, int id) = NULL;

void (*kh_ipcsem_wakeup_process)(struct sem_queue *q,
				 int error) = NULL;
int (*kh_ipcsem_copy_semundo)(unsigned long clone_flags,
			      struct task_struct *tsk) = NULL;

struct sem_undo * (*kh_ipcsem_find_undo)(struct sem_array* sma) = NULL;

void (*kh_ipcsem_exit_sem)(struct task_struct *tsk) = NULL;

/** Kerrighed Definitions **/
struct vm_operations_struct krg_shmem_vmops;
struct lock_class_key ipcid_lock_key;

/** Kerrighed Exported Symbols **/

EXPORT_SYMBOL(ipc_rcu_alloc);
EXPORT_SYMBOL(ipc_addid);
EXPORT_SYMBOL(ipc_rcu_putref);
EXPORT_SYMBOL(ipcid_lock_key);
EXPORT_SYMBOL(grow_ary);
EXPORT_SYMBOL(init_ipc_ns);
EXPORT_SYMBOL(ipc_lock);
EXPORT_SYMBOL(ipc_unlock);

/* export for Shared Memory segment */
EXPORT_SYMBOL(shm_inc);
EXPORT_SYMBOL(shm_close);
EXPORT_SYMBOL(krg_shmem_vmops);
EXPORT_SYMBOL(_shm_destroy);
EXPORT_SYMBOL(shmem_file_setup);
EXPORT_SYMBOL(shm_file_operations);
EXPORT_SYMBOL(kh_shm_lock);
EXPORT_SYMBOL(kh_shm_unlock);
EXPORT_SYMBOL(kh_shm_newseg);
EXPORT_SYMBOL(kh_shm_destroy);
EXPORT_SYMBOL(kh_shm_rmkey);
EXPORT_SYMBOL(kh_ipc_get_max_id);
EXPORT_SYMBOL(kh_get_ipc_id);
EXPORT_SYMBOL(kh_ipc_findkey);

/* export for Msg Queue */
EXPORT_SYMBOL(kh_ipcmsg_lock);
EXPORT_SYMBOL(kh_ipcmsg_unlock);
EXPORT_SYMBOL(kh_ipcmsg_newque);
EXPORT_SYMBOL(kh_ipcmsg_freeque);
EXPORT_SYMBOL(kh_ipcmsg_rmid);
EXPORT_SYMBOL(kh_ipc_msgsnd);
EXPORT_SYMBOL(kh_ipc_msgrcv);
EXPORT_SYMBOL(__do_msgrcv);
EXPORT_SYMBOL(__do_msgsnd);
EXPORT_SYMBOL(__freeque);
EXPORT_SYMBOL(sys_msgctl);

/* export for Semaphore */
EXPORT_SYMBOL(kh_ipcsem_newary);
EXPORT_SYMBOL(kh_ipcsem_freeary);
EXPORT_SYMBOL(kh_ipcsem_lock);
EXPORT_SYMBOL(kh_ipcsem_unlock);
EXPORT_SYMBOL(kh_ipcsem_wakeup_process);
EXPORT_SYMBOL(kh_ipcsem_copy_semundo);
EXPORT_SYMBOL(kh_ipcsem_find_undo);
EXPORT_SYMBOL(kh_ipcsem_exit_sem);
EXPORT_SYMBOL(__freeary);
EXPORT_SYMBOL(append_to_remote_queue);
EXPORT_SYMBOL(remove_from_remote_queue);
EXPORT_SYMBOL(__remove_from_queue);
EXPORT_SYMBOL(__exit_sem_found);
