/*
 *  Copyright (C) 2006-2007, Renaud Lottiaux, Kerlabs.
 */

#include <linux/module.h>
#include <linux/mm.h>
#include <linux/rmap.h>
#include <linux/pagemap.h>
#include <linux/swap.h>
#include <asm/pgalloc.h>
#include <asm/tlbflush.h>


/** Kerrighed Kernel Hooks **/

int (*kh_copy_mm)(unsigned long clone_flags, struct mm_struct *mm,
 		  struct mm_struct *oldmm) = NULL;

void (*kh_mmdrop) (struct mm_struct *mm) = NULL;


/* Default functions in case no vdso vm_ops is defined. */
__attribute__((weak)) int syscall_vm_ops_krgsyms_register(void)
{
	return 0;
}

__attribute__((weak)) int syscall_vm_ops_krgsyms_unregister(void)
{
	return 0;
}


/** Kerrighed Exported Symbols **/

EXPORT_SYMBOL(next_online_pgdat);
EXPORT_SYMBOL(first_online_pgdat);

EXPORT_SYMBOL(kh_mmdrop);
EXPORT_SYMBOL(kh_copy_mm);
EXPORT_SYMBOL(try_to_unmap);
EXPORT_SYMBOL(generic_file_vm_ops);
EXPORT_SYMBOL(syscall_vm_ops_krgsyms_register);
EXPORT_SYMBOL(syscall_vm_ops_krgsyms_unregister);
EXPORT_SYMBOL(arch_vma_name);
EXPORT_SYMBOL(insert_vm_struct);
EXPORT_SYMBOL(copy_page_range);
EXPORT_SYMBOL(vm_area_cachep);
EXPORT_SYMBOL(mm_cachep);
#ifndef CONFIG_X86_64
EXPORT_SYMBOL(empty_zero_page);
#endif
EXPORT_SYMBOL(exit_mm);
EXPORT_SYMBOL(anon_vma_prepare);
EXPORT_SYMBOL(page_add_anon_rmap);
EXPORT_SYMBOL(lru_cache_add_active);
EXPORT_SYMBOL(page_add_file_rmap);
EXPORT_SYMBOL(mmlist_lock);
#ifdef CONFIG_USERMODE
EXPORT_SYMBOL(mk_pte);
EXPORT_SYMBOL(flush_tlb_page);
EXPORT_SYMBOL(flush_tlb_all);
#else // CONFIG_USERMODE
EXPORT_SYMBOL(alloc_ldt);
#ifdef CONFIG_SMP
EXPORT_SYMBOL(flush_tlb_all);
#endif
#endif // CONFIG_USERMODE
EXPORT_SYMBOL(pgd_alloc);
EXPORT_SYMBOL(__pmd_alloc);
EXPORT_SYMBOL(__pud_alloc);
EXPORT_SYMBOL(pgd_free);
EXPORT_SYMBOL(find_vma_prev);
EXPORT_SYMBOL(page_remove_rmap);
EXPORT_SYMBOL(add_to_page_cache_lru);
EXPORT_SYMBOL(remove_from_page_cache);
EXPORT_SYMBOL(arch_unmap_area);
EXPORT_SYMBOL(arch_get_unmapped_area);
EXPORT_SYMBOL(arch_unmap_area_topdown);
EXPORT_SYMBOL(arch_get_unmapped_area_topdown);
EXPORT_SYMBOL(shmem_vm_ops);
EXPORT_SYMBOL(__pte_alloc);
EXPORT_SYMBOL(__mmdrop);
#ifdef CONFIG_X86_64
EXPORT_SYMBOL(pgd_list);
EXPORT_SYMBOL(pgd_lock);
#endif
#ifdef CONFIG_X86_PAE
EXPORT_SYMBOL(__supported_pte_mask);
#endif
