#include <linux/module.h>

#include <kerrighed/sys/types.h>
#include <kerrighed/krgnodemask.h>
#include <kerrighed/krginit.h>
#include <kerrighed/hotplug.h>

krgnodemask_t krgnode_possible_map;
EXPORT_SYMBOL(krgnode_possible_map);

krgnodemask_t krgnode_online_map;
EXPORT_SYMBOL(krgnode_online_map);

krgnodemask_t krgnode_present_map;
EXPORT_SYMBOL(krgnode_present_map);

struct universe_elem universe[KERRIGHED_MAX_NODES];
EXPORT_SYMBOL(universe);

void (*kh_cluster_autostart)(void);
EXPORT_SYMBOL(kh_cluster_autostart);

void krg_node_arrival(kerrighed_node_t nodeid)
{
	universe[nodeid].state = 1;
	set_krgnode_present(nodeid);

	if (kh_cluster_autostart)
		kh_cluster_autostart();
}

void krg_node_departure(kerrighed_node_t nodeid)
{
	universe[nodeid].state = 0;
	clear_krgnode_present(nodeid);
}

void init_node_discovering(void)
{
	int i;

	krgnodes_clear(krgnode_possible_map);
	krgnodes_clear(krgnode_online_map);
	krgnodes_clear(krgnode_present_map);
	
	for (i = 0; i < KERRIGHED_MAX_NODES; i++) {
		universe[i].state = 0;
		universe[i].subid = -1;
	}

	if (ISSET_KRG_INIT_FLAGS(KRG_INITFLAGS_NODEID)) {
		universe[kerrighed_node_id].state = 1;
		set_krgnode_present(kerrighed_node_id);
	}
}
